var workflowUserInterfaceEmployeeInfoTimer = null;
var workflowUserInterfaceAreaInfoTimer = null;
var workflowUserInterfaceCurrentAreaID = 0;

String.prototype.repeat = function(l)
{
	return new Array(l+1).join(this);
};

/* define the orgchart layout */
function createOrgchartLayout()
{
	var content = '<div id="orgchartMenu"></div>';
	content += '<div class="orgchartAreas" id="orgchartAreas"></div>';
	content += '<div class="orgchartEmployees" id="orgchartEmployees"></div>';
	content += '<div class="orgchartFooter" id="orgchartFooter"></div>';
	content += '<div id="employeeInfo" class="employeeInfo" style="display: none;"></div>';
	content += '<div id="areaInfo" class="employeeInfo" style="display: none;"></div>';

	var div = $('content_id_4');
	div.innerHTML = content;

	draw_orgchart_folder();
}

/* generates the orgchart menu */
function createOrgchartMenu(organizationID, imagemURL)
{
	var enderecoImagem = '';
	if ((imagemURL != null) && (imagemURL != ''))
		enderecoImagem = imagemURL;
	else
		enderecoImagem = '../index.php?menuaction=workflow.ui_orgchart.graph&organizationID=' + organizationID;

	var content = '<ul class="horizontalMenu">';
	content += '<li style="margin: 5px 5px 0 5px">Visualizar : <select onclick="this.parentNode.parentNode.lastChild.style.display = (this.options[1].selected) ? \'block\' : \'none\' ">'
	content += '<option onclick="getAlphabeticalEmployees( )">Alfabtica</option>'
	content += '<option onclick="getHierarchicalArea( );" selected="true">reas</option>'
	content += '<option onclick="getCostCenters( );">Centros de Custo</option>'
	content += '<option onclick="getManning( )">Localidades</option>'
	content += '<option onclick="getAreaWithSubtituteBoss( )">Substituio de Chefia</option>'
	content += '<option onclick="getUsefulPhones( );">Telefones teis</option>'
	content += '<option onclick="getCategoriesList( )">Vnculos</option>'
	content += '</select></li>';
	content += '<li><a href="#" onclick="window.open(\'' + enderecoImagem + '\', \'extwindow\'); return false;"><img src="templateFile.php?file=images/Process.gif">&nbsp;&nbsp;Grfico</a></li>';
	content += '<li><a><input type="text" name="search_term" id="search_term" onkeypress="if (((event.which) ? event.which : event.keyCode) == 13) $(\'search_span\').onclick(); return true;" /><span id="search_span" style="cursor: pointer;" onclick="tmp = $$(\'div#orgchartAreas a.destaque\'); if (tmp[0]) tmp[0].removeClassName(\'destaque\'); orgchartSearchEmployee($F(\'search_term\')); return false;">&nbsp;busca</span></a></li>';
	content += '<li><a href="#" onclick="printArea(); return false;"><img src="templateFile.php?file=images/imprimir.png" width="16">&nbsp;&nbsp;Imprimir</a></li>';
	content += '</ul>';
	content += '<br/>';
	content += '<br/>';

	$('orgchartMenu').innerHTML = content;
}

/* load the initial data */
function draw_orgchart_folder()
{
	$('orgchartMenu').innerHTML = '';
	$('orgchartAreas').innerHTML = '';
	$('orgchartEmployees').innerHTML = '<br/><br/><br/><br/><center><i>&nbsp;&nbsp;carregando...<br/><img src="templateFile.php?file=images/loading.gif"></i></center>';
	$('orgchartFooter').innerHTML = '';
	$('orgchartMenu').innerHTML = '';

	cExecute("$this.bo_userinterface.orgchart", orgchart, "");
}

/* process the initial data */
function orgchart(data)
{
	if (_checkError(data))
		return;

	/* in case of any warning */
	if (data['warning'])
	{
		$('content_id_4').innerHTML = '<br/><br/><center><strong>' + data['warning'] + '</strong></center><br/><br/>';
		return;
	}

	if (data['areas'].length == 0)
	{
		$('content_id_4').innerHTML = "<br/><br/><center><strong>Nenhuma rea cadastrada.</strong></center><br/><br/>";
		return;
	}

	/* continue displaying the data */
	displayHierarchicalAreas(data['areas']);
	createOrgchartMenu(data['organizacao_id'], data['url_imagem']);
	$('orgchartEmployees').innerHTML = '<br/><br/><br/><br/><center><i>faa uma busca ou clique em uma rea para ver a lista de funcionrios</i></center>';
}

function displayCostCenters(data)
{
	if (_checkError(data))
		return;

	var div = $('orgchartEmployees');
	if (data.length == 0)
	{
		div.innerHTML = '<br/><br/><center><strong>Nenhum registro encontrado</strong></center>';
		return;
	}

	var content = '';
	content += '<table class="employeeList">';
	content += '<tr><th>Nome</th><th>Nmero</th><th>Grupo</th></tr>';
	var current;
	var costCentersCount = data.length;
	for (var i = 0; i < costCentersCount; i++)
	{
		current = data[i];
		content += '<tr class="linha'+ i%2 + '">';
		content += '<td>' + current['descricao'] + '</td>';
		content += '<td>' + current['nm_centro_custo'] + '</td>';
		content += '<td>' + current['grupo'] + '</td>';
		content += '</tr>';
	}
	content += '</table>';
	div.innerHTML = content;
}

function displayUsefulPhones( data )
{
	if ( _checkError( data ) )
		return;

	var div = $('orgchartEmployees');
	if (data.length == 0)
	{
		div.innerHTML = '<br/><br/><center><strong>Nenhum registro encontrado</strong></center>';
		return;
	}

	var content = '';
	content += '<table class="employeeList">';
	content += '<tr><th>Localidade</th><th>Nmero</th></tr>';
	var current;
	var usefulPhoneCount = data.length;
	for (var i = 0; i < usefulPhoneCount; i++)
	{
		current = data[i];
		content += '<tr class="linha'+ i%2 + '">';
		content += '<td>' + current[ 'descricao' ] + '</td>';
		content += '<td>' + current[ 'numero' ] + '</td>';
		content += '</tr>';
	}
	content += '</table>';
	div.innerHTML = content;
}

function displayAreaWithSubtituteBoss( data )
{
	if ( _checkError( data ) )
		return;

	var div = $('orgchartEmployees');
	if (data.length == 0)
	{
		div.innerHTML = '<br/><br/><center><strong>Nenhum registro encontrado</strong></center>';
		return;
	}

	var content = '';
	content += '<table class="employeeList">';
	content += '<tr><th>rea</th><th>Titular</th><th>Substituto</th></tr>';
	var current;
	var usefulPhoneCount = data.length;
	for (var i = 0; i < usefulPhoneCount; i++)
	{
		current = data[i];
		content += '<tr class="linha'+ i%2 + '">';
		content += '<td>' + current['area'] + '</td>';
		content += '<td>' + current['titular'] + '</td>';
		content += '<td>' + current['substituto'] + '</td>';
		content += '</tr>';
	}
	content += '</table>';
	div.innerHTML = content;
}

function displayHierarchicalAreas(data)
{
	if (_checkError(data))
		return;

	function recursivePrint(subdata)
	{
		for (var i = 0; i < subdata.length; i++)
		{
			div.innerHTML += '<br />' + '&nbsp;&nbsp;&nbsp;&nbsp;'.repeat(subdata[i]['depth']) + '<a href="javascript:void(0)" id="area_' + subdata[i]['area_id'] + '" onmouseover="getAreaInfoTimer(event, ' + subdata[i]['area_id'] + '); return false;" onmouseout="hideAreaInfo(); return false;" onclick="tmp = $$(\'div#orgchartAreas a.destaque\'); if (tmp[0]) tmp[0].removeClassName(\'destaque\'); this.addClassName(\'destaque\'); loadAreaEmployees(' + subdata[i]['area_id'] + ')">' + subdata[i]['sigla'] + '</a>';
			if (subdata[i]['children'].length > 0)
				recursivePrint(subdata[i]['children']);
		}
	}

	var div = $('orgchartAreas');
	div.innerHTML = "<center><strong>REAS</strong></center>";
	recursivePrint(data);
}

function getUsefulPhones( )
{
	workflowUserInterfaceCurrentAreaID = 0;

	cExecute("$this.bo_userinterface.getUsefulPhones", displayUsefulPhones, "");
}

function getAreaWithSubtituteBoss( )
{
	workflowUserInterfaceCurrentAreaID = 0;

	cExecute("$this.bo_userinterface.getAreaWithSubtituteBoss", displayAreaWithSubtituteBoss, "");
}

function getCostCenters()
{
	workflowUserInterfaceCurrentAreaID = 0;

	cExecute("$this.bo_userinterface.getCostCenters", displayCostCenters, "");
}

function getHierarchicalArea()
{
	workflowUserInterfaceCurrentAreaID = 0;

	cExecute("$this.bo_userinterface.getHierarchicalArea", displayHierarchicalAreas, "");
}

function getAreaList()
{
	cExecute("$this.bo_userinterface.getAreaList", displayHierarchicalAreas, "");
}

function getCategoriesList()
{
	workflowUserInterfaceCurrentAreaID = 0;

	var div = $('orgchartEmployees');
	div.innerHTML = '';

	function resultGetCategoriesList(data)
	{
		if (_checkError(data))
			return;

		var content = '<center><strong>VNCULOS</strong></center>';
		for (var i = 0; i < data.length; i++)
			content += '<br/>' + '&nbsp;&nbsp;<a href="javascript:void(0)" id="categoria_' + data[i]['funcionario_categoria_id'] + '" onclick="tmp = $$(\'div#orgchartAreas a.destaque\'); if (tmp[0]) tmp[0].removeClassName(\'destaque\'); this.addClassName(\'destaque\'); loadCategoryEmployees(' + data[i]['funcionario_categoria_id'] + ')">' + data[i]['descricao'] + ' (' + data[i]['contagem'] + ')</a>';
		content += '<br/><br/>';
		$('orgchartAreas').innerHTML = content;
	}

	cExecute("$this.bo_userinterface.getCategoriesList", resultGetCategoriesList, "");
}

function getManning( )
{
	workflowUserInterfaceCurrentAreaID = 0;

	var div = $('orgchartEmployees');
	div.innerHTML = '';

	function resultGetManning( data )
	{
		if ( _checkError( data ) )
			return;

		var content = '<center><strong>Localidades</strong></center>';
		for ( var i = 0; i < data.length; i++ )
			content += '<br/>' + '&nbsp;<a href="javascript:void(0)" id="localidade_' + data[i]['localidade_id'] + '" onclick="tmp = $$(\'div#orgchartAreas a.destaque\'); if (tmp[0]) tmp[0].removeClassName(\'destaque\'); this.addClassName(\'destaque\');loadManningEmployees(' + data[i]['localidade_id'] + ')">' + data[i]['descricao'] + '</a>';

		content += '<br/><br/>';

		$('orgchartAreas').innerHTML = content;
	}

	cExecute("$this.bo_userinterface.getManning", resultGetManning, "");
}

function printEmployeesHandler(data)
{
	/* check for errors */
	if (_checkError(data))
		return;

	var div = $('orgchartEmployees');

	/* no employee to list */
	if (data['employees'].length == 0)
	{
		div.innerHTML = '<br/><br/><center><strong>Nenhum registro encontrado</strong></center>';
		return;
	}

	/* initialize varivables */
	var content = '';
	var employees = data['employees'];
	var useCategories = false;
	var useArea = false;

	/* check the informations that will be displayed */
	if (data['categories'])
		if (data['categories'].length > 1)
			useCategories = true;
	if (employees[0]['area'])
		useArea = true;

	/* build the display table (headers)*/
	content += '<table id="employeeList" class="employeeList" style="clear: both">';
	content += '<tr>';
	content += '<th>Funcionrio</th>';
	if (useArea)
		content += '<th>rea</th>';
	content += '<th>Telefone</th>';
	content += '</tr>';

	/* if available, insert a menu to filter the categories */
	if (useCategories)
	{
		content += '<tr><td colspan="' + (useArea ? '3' : '2') + '">';
		content += '<ul class="horizontalMenu">';
		for (var i = 0; i < data['categories'].length; i++)
			content += '<li><a href="#" style="height: 2em; line-height: 2em;" onclick="highlightCategory(' + data['categories'][i]['funcionario_categoria_id'] + '); return false;">' + data['categories'][i]['descricao'] + ' (' + data['categories'][i]['contagem'] + ')</a></li>';
		content += '</ul>';
		content += '</td></tr>';
	}

	/* list the employees */
	var complement = '';
	for (var i = 0; i < employees.length; i++)
	{
		if (employees[i]['chief'])
			complement = ' <strong>(' + ((employees[i]['chief'] == 1) ? 'Titular' : 'Substituto') + ')</strong>';
		else
			complement = '';
		if (employees[i]['removed'])
			complement += ' <font color="red">(excludo)</font>';
		content += '<tr class="linha'+ i%2 + (useCategories ? ' categoria_' + employees[i]['funcionario_categoria_id'] : '') + '">';
		content += '<td><a href="javascript:void(0);" onmouseover="getEmployeeInfoTimer(event, ' + employees[i]['funcionario_id'] + '); return false;" onmouseout="hideEmployeeInfo(); return false;">' + employees[i]['cn'] + complement + '</a></td>';
		if (useArea)
			content += '<td>' + employees[i]['area'] + '</td>';
		content += '<td align="center">' + employees[i]['telephoneNumber'] + '</td>';
		content += '</tr>';
	}
	content += '</table>';

	/* display the employees list and go to the top of the page */
	div.innerHTML = content;
	window.scrollTo(0,0);
}

function highlightCategory(categoryID)
{
	var rows = $('employeeList').childNodes[0].childNodes;
	var categoryClass = 'categoria_' + categoryID;

	var highlightClass = '';
	var row;
	for (var i = 1; i < rows.length; i++)
	{
		row = $(rows[i]);
		/* in case alternated color rows are needed, just change the second 'highlight0' to something else (e.g. 'highlight1' which is alread defined) */
		highlightClass = row.hasClassName('linha0') ? 'highlight0' : 'highlight0';
		if (row.hasClassName(categoryClass))
			row.addClassName(highlightClass);
		else
			row.removeClassName(highlightClass);
	}
}

function loadAreaEmployees(areaID)
{
	workflowUserInterfaceCurrentAreaID = areaID;
	cExecute('$this.bo_userinterface.getAreaEmployees', printEmployeesHandler, 'areaID=' + areaID);
}

function loadCategoryEmployees(categoryID)
{
	workflowUserInterfaceCurrentAreaID = 0;
	cExecute('$this.bo_userinterface.getCategoryEmployees', printEmployeesHandler, 'categoryID=' + categoryID);
}

function loadManningEmployees( locationID )
{
	workflowUserInterfaceCurrentAreaID = 0;
	cExecute('$this.bo_userinterface.getManningEmployees', printEmployeesHandler, 'locationID=' + locationID);
}

function getAlphabeticalEmployees( )
{
	workflowUserInterfaceCurrentAreaID = 0;

	var div = $('orgchartEmployees');
	div.innerHTML = '';

	var p_page = 0;
	if ( arguments.length )
	{
		p_page = parseInt(arguments[ 0 ]);
		if ( isNaN( p_page ) )
			p_page = 0;
	}
	cExecute('$this.bo_userinterface.getAlphabeticalEmployees', function( data )
	{
		var pagingData = data['paging_links'];
		var output = '';
		if (pagingData)
		{
			var pagingSize = pagingData.length;
			for (var i = 0; i < pagingSize; i++)
			{
				if (pagingData[i].do_link == true)
					output += '<a style="font-size: 13px" href="#" onclick="getAlphabeticalEmployees(' + pagingData[i].p_page + ');">' + pagingData[i].name + '</a>&nbsp;';
				else
					output += '<strong style="font-size: 14px">' + pagingData[i].name + '</strong>&nbsp;';
			}
		}

		printEmployeesHandler( data );

		div.innerHTML += '<br /><center>' + output + '</center>';
	}, 'p_page='+p_page);
}

function orgchartSearchEmployee(searchTerm)
{
	workflowUserInterfaceCurrentAreaID = 0;
	cExecute('$this.bo_userinterface.searchEmployee', printEmployeesHandler, 'searchTerm=' + searchTerm);
}

function printArea()
{
	if (workflowUserInterfaceCurrentAreaID == 0)
		if (!confirm('Tem certeza de que deseja imprimir todo o Organograma?'))
			return false;
	var endereco = '../index.php?menuaction=workflow.ui_userinterface.printArea&areaID=' + workflowUserInterfaceCurrentAreaID;
	window.open(endereco, 'extwindow');
}

function getEmployeeInfoTimer(e, employeeID)
{
	var div = $('employeeInfo');
	div.style.left = (Event.pointerX(e) + 20) + 'px';
	div.style.top = (Event.pointerY(e) + 14) + 'px';

	if (workflowUserInterfaceEmployeeInfoTimer != null)
	{
		workflowUserInterfaceEmployeeInfoTimer = clearTimeout(workflowUserInterfaceEmployeeInfoTimer);
		workflowUserInterfaceEmployeeInfoTimer = null;
	}

	workflowUserInterfaceEmployeeInfoTimer = setTimeout('getEmployeeInfo(' + employeeID + ')', 500);
}

function getEmployeeInfo(employeeID)
{
	function resultGetEmployeeInfo(data)
	{
		if (workflowUserInterfaceEmployeeInfoTimer == null)
			return;

		workflowUserInterfaceEmployeeInfoTimer = clearTimeout(workflowUserInterfaceEmployeeInfoTimer);
		workflowUserInterfaceEmployeeInfoTimer = null;

		var card_data = [ ];

		for (var i = 0; i < data['info'].length; i++)
			card_data[ data[ 'info' ][ i ][ 'name' ] ] = data[ 'info' ][ i ][ 'value' ];

		var card = document.createElement( 'div' );
		card.style.fontSize = '12px';
		card.style.padding = '5px';
		card.style.marginRight = '70px';

		var photo = document.createElement( 'img' );
		photo.src = 'showUserPicture.php?userID=' + employeeID;
		photo.style.position = 'absolute';
		photo.style.right = '10px';

		card.appendChild( photo );

		if ( card_data[ 'Nome' ] )
		{
			var name = document.createElement( 'span' );
			name.style.fontWeight = 'bold';
			name.appendChild( document.createTextNode( card_data[ 'Nome' ] ) );
			card.appendChild( name );
			card.appendChild( document.createElement( 'br' ) );
		}

		if ( card_data[ 'Ttulo' ] )
			var role = card.appendChild( document.createTextNode( card_data[ 'Ttulo' ] ) );

		if ( card_data[ 'rea' ] )
		{
			if ( role )
				card.appendChild( document.createTextNode( ' - ' ) );
			card.appendChild( document.createTextNode( card_data[ 'rea' ] ) );
		}

		card.appendChild( document.createElement( 'br' ) );
		card.appendChild( document.createElement( 'br' ) );

		if ( card_data[ 'Empresa' ] )
		{
			var company = document.createElement( 'span' );
			company.style.fontWeight = 'bold';
			company.appendChild( document.createTextNode( card_data[ 'Empresa' ] ) );
			card.appendChild( company );
			card.appendChild( document.createElement( 'br' ) );
		}

		if ( card_data[ 'Endereo' ] )
			var address = card.appendChild( document.createTextNode( card_data[ 'Endereo' ] ) );

		if ( card_data[ 'Complemento' ] )
		{
			if ( address )
				card.appendChild( document.createTextNode( ' - ' ) );
			var complement = card.appendChild( document.createTextNode( card_data[ 'Complemento' ] ) );
		}

		if ( address || complement )
			card.appendChild( document.createElement( 'br' ) );

		if ( card_data[ 'Cep' ] )
			var zipcode = card.appendChild( document.createTextNode( card_data[ 'Cep' ] ) );

		if ( card_data[ 'Bairro' ] )
		{
			if ( zipcode )
				card.appendChild( document.createTextNode( ' - ' ) );
			var district = card.appendChild( document.createTextNode( card_data[ 'Bairro' ] ) );
		}

		if ( zipcode || district )
			card.appendChild( document.createElement( 'br' ) );

		if ( card_data[ 'Cidade' ] )
			var city = card.appendChild( document.createTextNode( card_data[ 'Cidade' ] ) );

		if ( card_data[ 'UF' ] )
		{
			if ( city )
				card.appendChild( document.createTextNode( ' - ' ) );
			card.appendChild( document.createTextNode( card_data[ 'UF' ] ) );
		}

		card.appendChild( document.createElement( 'br' ) );
		card.appendChild( document.createElement( 'br' ) );

		if ( card_data[ 'Telefone' ] )
		{
			var phone = document.createElement( 'span' );
			phone.appendChild( document.createTextNode( card_data[ 'Telefone' ] ) );
			phone.style.paddingLeft = '20px';
			phone.style.whiteSpace = 'nowrap';
			phone.style.background = 'url(templateFile.php?file=images/phone.png) no-repeat 0 0';
			card.appendChild( phone );
		}

		card.appendChild( document.createElement( 'br' ) );
		card.appendChild( document.createElement( 'br' ) );

		if ( card_data[ 'e-mail' ] )
		{
			var mail = document.createElement( 'span' );
			mail.appendChild( document.createTextNode( card_data[ 'e-mail' ] ) );
			mail.style.paddingLeft = '20px';
			mail.style.whiteSpace = 'nowrap';
			mail.style.background = 'url(templateFile.php?file=images/mail.png) no-repeat 0 0';
			card.appendChild( mail );
		}

		card.appendChild( document.createElement( 'br' ) );

		if ( card_data[ 'sitio' ] )
		{
			var sitio = document.createElement( 'span' );
			sitio.appendChild( document.createTextNode( card_data[ 'sitio' ] ) );
			sitio.style.paddingLeft = '20px';
			sitio.style.background = 'url(templateFile.php?file=images/sitio.png) no-repeat 0 2px';
			card.appendChild( sitio );
		}

		var pageYLimit = document.body.scrollTop + document.body.clientHeight;
		var div = $('employeeInfo');

		div.innerHTML = '';
		div.appendChild( card );

		if ((parseInt(div.style.top.replace(/px/g, '')) + div.getHeight()) > pageYLimit)
			div.style.top = (parseInt(div.style.top.replace(/px/g, '')) - (div.getHeight())) + 'px';
		div.show();
	}
	cExecute('$this.bo_userinterface.getEmployeeInfo', resultGetEmployeeInfo, 'funcionario_id=' + employeeID);
}

function hideEmployeeInfo()
{
	if (workflowUserInterfaceEmployeeInfoTimer != null)
	{
		workflowUserInterfaceEmployeeInfoTimer = clearTimeout(workflowUserInterfaceEmployeeInfoTimer);
		workflowUserInterfaceEmployeeInfoTimer = null;
	}
	$('employeeInfo').hide();
}

function getAreaInfoTimer(e, areaID)
{
	var div = $('areaInfo');
	div.style.left = (Event.pointerX(e) + 20) + 'px';
	div.style.top = (Event.pointerY(e) + 14) + 'px';

	if (workflowUserInterfaceAreaInfoTimer != null)
	{
		workflowUserInterfaceAreaInfoTimer = clearTimeout(workflowUserInterfaceAreaInfoTimer);
		workflowUserInterfaceAreaInfoTimer = null;
	}

	workflowUserInterfaceAreaInfoTimer = setTimeout('getAreaInfo(' + areaID + ')', 500);
}

function getAreaInfo(areaID)
{
	function resultGetAreaInfo(data)
	{
		if (workflowUserInterfaceAreaInfoTimer == null)
			return;

		workflowUserInterfaceAreaInfoTimer = clearTimeout(workflowUserInterfaceAreaInfoTimer);
		workflowUserInterfaceAreaInfoTimer = null;

		var content = '';
		content += '<table><tr>';
		content += '<td valign="top" style="padding-left: 12px;">';
		for (var i = 0; i < data['info'].length; i++)
			content += '<strong>' + data['info'][i]['name'] + '</strong>: ' + data['info'][i]['value'] + '<br/>';

		content += '</td></tr></table>';
		var pageYLimit = document.body.scrollTop + document.body.clientHeight;
		var div = $('areaInfo');
		div.innerHTML = content;

		if ((parseInt(div.style.top.replace(/px/g, '')) + div.getHeight()) > pageYLimit)
			div.style.top = (parseInt(div.style.top.replace(/px/g, '')) - (div.getHeight())) + 'px';
		div.show();
	}
	cExecute('$this.bo_userinterface.getAreaInfo', resultGetAreaInfo, 'area_id=' + areaID);
}

function hideAreaInfo()
{
	if (workflowUserInterfaceAreaInfoTimer != null)
	{
		workflowUserInterfaceAreaInfoTimer = clearTimeout(workflowUserInterfaceAreaInfoTimer);
		workflowUserInterfaceAreaInfoTimer = null;
	}
	$('areaInfo').hide();
}
